var propertySetDivName;
var selectedValue;

var IE_BROWSER_NAME = "Microsoft";
var NETSCAPE_BROWSER_NAME = "Netscape";

var paneloverlaymanager = null;

var TYPE_INFO = "INFO";
var TYPE_WARN = "WARN";
var TYPE_ERROR = "ERROR";

var messageheader = new Array();
messageheader[TYPE_INFO] = "Information Message";
messageheader[TYPE_WARN] = "Warning Message";
messageheader[TYPE_ERROR] = "Error Message";

function initoverlaymanager() {
    if (paneloverlaymanager == null) {
        paneloverlaymanager = new YAHOO.widget.OverlayManager();
    }
}

function namevalidate(namestring) {

    if(namestring.indexOf("'") == -1 && namestring.indexOf(" ") == -1 && namestring.indexOf("&") == -1 && namestring.indexOf('"') == -1) {
        return true;
    } else {
        return false;
    }
}

function populatePropertySet(divName, defaultValue) {
    propertySetDivName = divName;
    selectedValue = defaultValue;

    var body_xml = '<ns1:getEntryNames xmlns:ns1="http://org.apache.synapse/xsd">' +
                   '</ns1:getEntryNames>';

    var callURL = serverURL + "/" + ENTRIES_MANAGEMENT + "/" + "getEntryNames";

    send("getEntryNames", body_xml, "", callURL, "", false, populatePropertySetCallback);
}

function populatePropertySetCallback() {

    if (!onError()) {
        return;
    }

    var keySelect = document.getElementById(propertySetDivName);

    if (xhReq.responseXML != null) {

        var entries = xhReq.responseXML.getElementsByTagName("return");
        keySelect.options[0] = new Option("Select Property", "");

        for (var i = 0; i < entries.length; i++) {

            var key = entries[i].textContent;
            keySelect.options[i + 1] = new Option(key, key);

            if (key == selectedValue) {
                keySelect.options[i + 1].selected = true;
            }
        }
    }
}

function createesbelement(elementstring) {

    // **************************************************** removing the unwanted characters in the string (woodstox ex)
    var filteredstring = "";
    while (elementstring.indexOf("\n") != -1) {
        var endlinepos = elementstring.indexOf("\n");
        filteredstring += elementstring.substring(0, endlinepos);
        if (endlinepos < elementstring.length) {
            elementstring = elementstring.substring(endlinepos + 1, elementstring.length);
        }
    }
    filteredstring += elementstring;
    while (filteredstring.indexOf("> ") != -1) {
        var spacepos = filteredstring.indexOf("> ");
        filteredstring = filteredstring.substring(0, spacepos + 1) + filteredstring.substring(spacepos + 2, filteredstring.length);
    }
    // ******************************************************

    var namewithnsprefix = filteredstring.split(" ", 1)[0];
    if (namewithnsprefix.indexOf("<") != -1) namewithnsprefix = namewithnsprefix.substring(1, namewithnsprefix.length);
    if (namewithnsprefix.indexOf("/>") != -1) namewithnsprefix = namewithnsprefix.substring(0, namewithnsprefix.length - 2);
    if (window.ActiveXObject) {
        var doc = new ActiveXObject("Microsoft.XMLDOM");
        doc.async = "false";
        if (doc.loadXML(filteredstring)) {
            return doc.getElementsByTagName(namewithnsprefix)[0];
        } else {
            esbwarning("Invalid XML configuration.. ", TYPE_WARN);
            return -1;
        }
    } else {
        var parser = new DOMParser();
        var doc = parser.parseFromString(filteredstring, "text/xml");
        if (doc.documentElement.nodeName == "parsererror") {
            esbwarning("Invalid XML configuration.. ", TYPE_WARN);
            return -1;
        } else {
            var namewonsprefix = namewithnsprefix.substring(namewithnsprefix.indexOf(":", 0) + 1, namewithnsprefix.length);
            return doc.getElementsByTagName(namewonsprefix)[0];
        }
    }
}

///////////////////////// YUI abstractions /////////////////////////////////////////////////////

function yuieditorpanel(paneltitle, panelbody, statusbartext, panelId, width) {

    var divcontrol;
    if(panelId == "panelSequence") {
        divcontrol = document.getElementById("sequencePanel");
    } else {
        divcontrol = document.getElementById("registryPanel");
    }
//    var divcontrol = document.getElementById("divOverPanel");
    divcontrol.innerHTML = "";
    var id = "myPanel";
    var panelcontrol = document.createElement("div");
    if (panelId != null && panelId != undefined) {
        id = panelId;
    }
    panelcontrol.setAttribute("id",id) ;
    panelcontrol.innerHTML = "<div class='hd'><div class='tl'></div>"
            + "<span>" + paneltitle + "</span><div class='tr'></div></div>"
            + "<div class='bd'>" + panelbody + "</div>"
            + "<div id='statusbar' class='ft'>" + statusbartext + "</div>";

    divcontrol.appendChild(panelcontrol);
//    panelcontrol.style.zIndex = 3;
    var esbpanel1 = new YAHOO.widget.Panel(id, {
        width:width, fixedcenter:true, visible:false, constraintoviewport:true });
    esbpanel1.render();
//    initoverlaymanager();
//    paneloverlaymanager.register(esbpanel1);
    divcontrol.style.display = "inline";
//    paneloverlaymanager.showAll();
    esbpanel1.show();
}
function transformXMLToString(xmlDoc, xslDocURL, objDiv) {
    if (browsername.indexOf(NETSCAPE_BROWSER_NAME) != -1) {
        processXML(xmlDoc, xslDocURL, objDiv);
        return new XMLSerializer().serializeToString(objDiv);
    }
    else if (browsername.indexOf(IE_BROWSER_NAME) != -1) {
        var fullPath = URL + "/extensions/core/xslt/" + xslDocURL;
        return transformXMLIE(xmlDoc, fullPath, objDiv);
    }
}
function transformXMLIE(xmlDoc, xslDocURL, objDiv, paramArray)
{
    // declare the local variables
    var xslDoc, docProcessor, docCache, DocRequest, docFragment;
    // try the following
    try
    {
        // instantiate and load the xsl document
        xslDoc = new ActiveXObject("MSXML2.FreeThreadedDOMDocument");
        xslDoc.async = false;
        xslDoc.load(xslDocURL);
        // prepare the xsl document for transformation
        docCache = new ActiveXObject("MSXML2.XSLTemplate");
        docCache.stylesheet = xslDoc;
        // instantiate the document processor and submit the xml document
        docProcessor = docCache.createProcessor();
        docProcessor.input = xmlDoc;
        // add parameters to the xsl document
        if (paramArray) {
            docProcessor.addParameter("topLevelHeading", paramArray[0], "");
        }
        // process the documents into html and submit to the passed div to the HMTL page
        docProcessor.transform();
        // divID.innerHTML = docProcessor.output;
        return "<div>" + docProcessor.output + "</div>";
    }
    // catch any errors from the above code
    catch(e) {
        esbwarning("Encounterd an error: " + e, TYPE_ERROR);
    }
}

function ltrim(str) {
 for (var k=0; k<str.length && str.charAt(k)<=" " ; k++) ;
 return str.substring(k,str.length);
}
function rtrim(str) {
 for (var j=str.length-1; j>=0 && str.charAt(j)<=" " ; j--) ;
 return str.substring(0,j+1);
}

//This function accepts a String and trims the string in both sides of the string ignoring space characters
function trim(stringValue){
//   var trimedString = stringValue.replace( /^\s+/g, "" );
//   return trimedString.replace( /\s+$/g, "" );
    return ltrim(rtrim(stringValue));
}

function esbwarning(message, type) {

    var handleOK = function() {
        this.hide();
    };

    var warning = null;
    switch(type) {
        case TYPE_INFO:
            warning = new YAHOO.widget.SimpleDialog("esbwarning", {width:"350px", fixedcenter:true, visible:false, draggable:true, close:true, text:message, icon:YAHOO.widget.SimpleDialog.ICON_INFO, constraintoviewport: true, buttons:[ { text:"OK", handler:handleOK, isDefault:true }]});
            break;
        case TYPE_WARN:
            warning = new YAHOO.widget.SimpleDialog("esbwarning", {width:"350px", fixedcenter:true, visible:false, draggable:true, close:true, text:message, icon:YAHOO.widget.SimpleDialog.ICON_WARN, constraintoviewport: true, buttons:[ { text:"OK", handler:handleOK, isDefault:true }]});
            break;
        case TYPE_ERROR:
            warning = new YAHOO.widget.SimpleDialog("esbwarning", {width:"350px", fixedcenter:true, visible:false, draggable:true, close:true, text:message, icon:YAHOO.widget.SimpleDialog.ICON_ALARM, constraintoviewport: true, buttons:[ { text:"OK", handler:handleOK, isDefault:true }]});
            break;
    }
    warning.setHeader(messageheader[type]);
    warning.render(document.body);
    warning.show();
}

function esbconfirmation() {

    var handleYes = function() {
        this.hide();
        return true;
    };

    var handleCancel = function() {
        this.hide();
        return false;
    };

    var warning = new YAHOO.widget.SimpleDialog("esbwarning", {width:"300px", fixedcenter:true, visible:false, draggable:true, close:true, text:"Do you want to continue?", icon:YAHOO.widget.SimpleDialog.ICON_HELP, constraintoviewport: true, buttons:[ { text:"Yes", handler:handleYes, isDefault:true }, { text:"Cancel", handler:handleCancel, isDefault:false }]});
    warning.setHeader("Are you sure?");
    warning.render(document.body);
    warning.show();
}