/*
 * Copyright (c) 2006, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * This js file is for the log mediator specific UI operations
 */

collectdata["class"] = function collectlogdata(mediator, validate) {

    var name = document.getElementById("class_name");
    if (name != null && name.value != null && name.value != "") {
        mediator.setAttribute("name", name.value);
    } else if(!validate) {
        esbwarning("The class name must be specified for the class mediator", TYPE_INFO);
        return false;
    }
    collectproppertydata(mediator);
    return true;
};

mediatorelementstring["class"] = function logstring() {
    return "<syn:class xmlns:syn='http://ws.apache.org/ns/synapse'/>";
};